declare @lol varchar(max);
--select @lol = coalesce(@lol,'') + emp.ENAME + ', ' from emp;
select @lol = case when @lol is null then emp.ENAME else @lol + ', ' + emp.ENAME end from emp;
select @lol as lol;

---

declare @ile int;
select @ile = count(*) from emp;
if @ile < 16
	begin
		insert into emp([EMPNO],ename) values (123,'Kowal');
		print 'dodano Kowala';
	end
else
	begin
		print 'nie dodano Kowala';
	end

select ename from emp;
go
---

create proc sal(@ile as int)
as
    select count(*) from emp where sal > @ile;
go

execute sal 1500 ;
go

drop proc sal;
GO

--4.	Napisz procedur suc do wstawiania dziaw do tabeli Dept. Procedura bdzie pobiera jako parametry: nr_dziau, nazw i lokalizacj. Naley sprawdzi, czy dzia o takiej nazwie lub lokalizacji ju istnieje. Jeeli istnieje, to nie wstawiamy nowego rekordu. 

create proc DEPTADD(@DEPTNO as int, @DNAME as varchar(max), @LOC as varchar(max)) 
as
	declare @ile int;
	select @ile = count(*) from dept where [DNAME] = @DNAME;

	if @ile > 0
		begin
			print @DNAME+' juz istnieje';
		end 
	else
		begin
			INSERT INTO [dbo].[DEPT]
					   ([DEPTNO]
					   ,[DNAME]
					   ,[LOC])
				 VALUES
					   (@DEPTNO
					   ,@DNAME
					   ,@LOC )
			print 'dodano '+@DNAME;
		end
GO

select * from dept;
execute DEPTADD 111, 'OPERATIONS2', 'DERP'
select * from dept;
go

drop proc DEPTADD
GO

--5.	Napisz procedur umoliwiajc uytkownikowi wprowadzanie nowych pracownikw do tabeli EMP.
--		Jako parametry bdziemy podawa nazwisko i nr dziau zatrudnianego pracownika. 
--		Procedura powinna wprowadzajc nowy rekord sprawdzi, czy wprowadzany dzia istnieje 
--		(jeeli nie, to naley zgosi bd) oraz obliczy mu pensj rwn minimalnemu zarobkowi w tym dziale. 
--		EMPNO nowego pracownika powinno zosta wyliczone jako najwysza istniejca warto w tabeli + 1.

create proc EMPADD(@ENAME as varchar(max), @DEPTNO as int) 
as
	declare @ile int;
	select @ile = count(*) from dept where DEPTNO = @DEPTNO;

	if @ile > 0
		begin
			declare @EMPNO int;
			SELECT @EMPNO = MAX(EMPNO) + 1 FROM EMP;
			declare @SAL int;
			SELECT @SAL = MIN(SAL) FROM EMP WHERE DEPTNO = @DEPTNO;

			INSERT INTO [dbo].[EMP]
					   ([EMPNO]
					   ,[ENAME]
					   ,[SAL]
					   ,[DEPTNO])
				 VALUES
					   (@EMPNO
					   ,@ENAME
					   ,@SAL
					   ,@DEPTNO)
		print 'DODANO ' +@ENAME+ ' DO DZIALU ' + CAST(@DEPTNO AS VARCHAR);
		end 
	else
		begin
			print 'DEPT #' + CAST(@DEPTNO AS VARCHAR) + ' NIE istnieje';
		end
GO

select * from EMP WHERE DEPTNO IN (10,20) ORDER BY DEPTNO,SAL DESC;
execute EMPADD 'ZBYCH',1
execute EMPADD 'ZBIG',10
execute EMPADD 'ZYGMUNT',20
select * from EMP WHERE DEPTNO IN (10,20) ORDER BY DEPTNO,SAL DESC;
go

drop proc EMPADD
GO